﻿using CapSensorBase;
using CommunityToolkit.Mvvm.Input;
using FLY.Thick.Base.Server;
using FLY.Thick.FilmCasting.Cap.Server;
using FlyADBase;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using Unity;

namespace FLY.Thick.FilmCasting.Cap.UI.Server
{
    /// <summary>
    /// PgMain.xaml 的交互逻辑
    /// </summary>
    public partial class PgMain : Page
    {

        PgMainVm viewModel;
        public PgMain()
        {
            InitializeComponent();
        }
        [Unity.InjectionMethod]
        public void Init(
            IUnityContainer container)
        {
            viewModel = new PgMainVm();
            container.BuildUp(viewModel);
            this.DataContext = viewModel;
        }
    }
    public class PgMainVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public SysParam SysParam { get; set; }

        public FlyAD7 FlyAd { get; set; }

        public CapSensor3 CapSensor { get; private set; }

        public DevSync DevSync { get; private set; }



        public RelayCommand SetupCmd { get; private set; }

        public RelayCommand RebootCmd { get; private set; }
        public RelayCommand SyncCmd { get; private set; }



        IUnityContainer container;


        public PgMainVm()
        {
            SetupCmd = new RelayCommand(Setup);
            RebootCmd = new RelayCommand(Reboot);

            SyncCmd = new RelayCommand(Sync);
        }


        [InjectionMethod]
        public void Init(
            IUnityContainer container,
            SysParam sysParam,
            FlyAD7 flyAd,
            CapSensor3 capSensor,
            DevSync devSync)
        {
            this.container = container;

            SysParam = sysParam;
            FlyAd = flyAd;

            CapSensor = capSensor;
            DevSync = devSync;
        }
        private void Reboot()
        {
            if (MessageBox.Show($"程序将要重启,是否确定?", "提示", MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No)
            {
                return;
            }
            System.Environment.CurrentDirectory = "../";
            FLY.AppHelper.AppJustOne.Restart();
        }

        private void Setup()
        {
            //打开设置页面

            WdSetup w = new WdSetup();
            container.BuildUp(w);
            w.Owner = App.Current.MainWindow;
            w.ShowDialog();
        }
        private void Sync()
        {
            if (MessageBox.Show("触发同步信号", "提示", MessageBoxButton.OK, MessageBoxImage.Warning) == MessageBoxResult.OK)
            {
                DevSync.Sync();
            }
        }
    }
}
