﻿using CapSensorBase;
using CommunityToolkit.Mvvm.Input;
using FLY.Thick.Base.Server;
using FlyADBase;
using System.ComponentModel;
using System.Windows;
using Unity;

namespace FLY.Thick.FilmCasting.Cap.UI.Server
{
    /// <summary>
    /// WdSetup.xaml 的交互逻辑
    /// </summary>
    public partial class WdSetup : Window
    {
        WdSetupVm viewModel;
        public WdSetup()
        {
            InitializeComponent();
        }
        [InjectionMethod]
        public void Init(IUnityContainer container)
        {
            viewModel = new WdSetupVm();
            container.BuildUp(viewModel);
            this.DataContext = viewModel;
        }
    }
    public class WdSetupVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public string Addr { get; set; }
        public string FlyAdAddr { get; set; }

        public string CapSensorAddr { get; set; }

        public RelayCommand OkCmd { get; private set; }

        SysParam sysParam;
        FlyAD7 flyAd;
        CapSensor3 capSensor;
        public WdSetupVm()
        {
            OkCmd = new RelayCommand(Ok);
        }



        [InjectionMethod]
        public void Init(
            SysParam sysParam,
            FlyAD7 flyAd,
            CapSensor3 capSensor)

        {
            this.sysParam = sysParam;
            this.flyAd = flyAd;
            this.capSensor = capSensor;

            Addr = sysParam.Addr;
            FlyAdAddr = flyAd.Addr;
            CapSensorAddr = capSensor.Addr;
        }

        private void Ok()
        {
            if (MessageBox.Show($"程序必须重启才能执行新的参数, 是否重启?", "提示", MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No)
            {
                return;
            }

            sysParam.Addr = Addr;
            sysParam.Save();

            flyAd.Addr = FlyAdAddr;
            flyAd.Save();

            capSensor.Addr = CapSensorAddr;
            capSensor.Save();

            System.Environment.CurrentDirectory = "../";
            AppHelper.AppJustOne.Restart();
        }
    }
}
