﻿using FLY.Thick.Base.IService;
using FObjBase;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.FilmCasting.Cap.Common
{
    public class FlyADIODefine : FLY.Thick.Base.Common.FlyADIODefine
    {
        public static new FlyADIODefine Instance => (FlyADIODefine)instance;

        /// <summary>
        /// 换卷信号 X8
        /// </summary>
        [Description("换卷信号")]
        public int InNo_Finish { get; protected set; } = 8;

        /// <summary>
        /// 拉伸前辊信号 X11
        /// </summary>
        [Description("拉伸前辊信号")]
        public int InNo_VBeforeStretching { get; protected set; } = 11;

        public FlyADIODefine() 
        {
            InNo_Sync = 0;//X0



            OutNo_Sync = 0;//Y0
            OutNo_Alarm = 3;//Y3
        }

        protected override List<string> GetInputPropertyNames()
        {
            return new List<string> {
                nameof(InNo_Sync),
                nameof(InNo_Org),
                nameof(InNo_Limit_Forw),
                nameof(InNo_Limit_Backw),
                nameof(InNo_Manual_Forw),
                nameof(InNo_Manual_Backw),
                nameof(InNo_Roll),
                nameof(InNo_Finish),
                nameof(InNo_VBeforeStretching)
            };
        }
        protected override List<string> GetOutputPropertyNames()
        {
            return new List<string> {
                nameof(OutNo_Sync),
                nameof(OutNo_Alarm)
            };
        }
    }
}
