﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using System.ComponentModel;
using FLY.Simulation.Flyad7;
using System.Threading.Tasks;
using System.Windows.Threading;
using FLY.Simulation.Blowing;
using FLY.Simulation.CapSensor;

namespace CapSimulator
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        MainVm viewModel;
        FLY.Simulation.Flyad7.FLYAD7 flyad7;
        FLY.Simulation.Blowing.Blowing blowing;
        KeXinPlc plc;

        public MainWindow()
        {
            InitializeComponent();

        }
        public void Init(GageAD gageAd, FLYAD7 flyad7, CapSensor2 capSensor, KeXinPlc plc, Blowing blowing) 
        {
            this.flyad7 = flyad7;
            this.blowing = blowing;
            this.plc = plc;

            viewModel = new MainVm();
            viewModel.Init(gageAd, flyad7, capSensor, plc);
            this.DataContext = viewModel;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            WindowBlowing wb = new WindowBlowing();
            wb.Init(blowing, plc);
            wb.ShowDialog();
        }


        private void btnPressScramClick(object sender, RoutedEventArgs e)
        {
            flyad7.ManualStop();
        }

        private void btnReleaseScramClick(object sender, RoutedEventArgs e)
        {
            flyad7.ManualRelease();
        }

        private void btnManualForwordClick(object sender, RoutedEventArgs e)
        {
            flyad7.ManualForw();
        }

        private void btnManualBackwordClick(object sender, RoutedEventArgs e)
        {
            flyad7.ManualBackw();
        }
    }


    public class MainVm : INotifyPropertyChanged
    {

        public int Position { get; set; }


        public int Speed { get; set; }



        public int Position2 { get; set; }

        public int Speed2 { get; set; }


        public int AD { get; set; }

        public int Hz { get; set; }

        public UInt16 IStatus { get; set; }

        public UInt16 OStatus { get; set; } = 0xf;



        public int TimeSpan1ms { get; set; }


        public int Surplus { get; set; } = 8000;

        private DispatcherTimer timer;
        private FLYAD7 flyad;
        private KeXinPlc plc;
        private CapSensor2 capSensor;
        GageAD gageAd;
        public FLY.Simulation.Flyad7.FLYAD7 FlyAd => flyad;
        public KeXinPlc Plc => plc;
        public GageAD GageAD => gageAd;
        public CapSensor2 CapSensor => capSensor;

        public MainVm()
        {
        }
        public void Init(GageAD gageAd, FLYAD7 flyad, CapSensor2 capSensor, KeXinPlc plc)
        {
            this.gageAd = gageAd;
            this.flyad = flyad;
            this.plc = plc;
            this.capSensor = capSensor;

            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(0.1);
            timer.Tick += new EventHandler(timer_Tick);
            timer.Start();
        }

        void timer_Tick(object sender, EventArgs e)
        {
            Position = flyad.Position;
            Position2 = flyad.Position2;
            AD = flyad.AD;
            Speed = flyad.Speed;
            Speed2 = flyad.Speed2;
            TimeSpan1ms = (int)flyad.TimeSpan1ms;
            IStatus = flyad.IStatus;
            OStatus = flyad.OStatus;
            Surplus = flyad.Surplus;

            Hz = capSensor.Hz;
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
