﻿using GeneralGommunication;
using Misc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Simulation.CapSensor
{
    public class CapSensorCore2 : Dev7EServer
    {
        COMMREQInServer COMMREQ_pushData;
        byte packno = 0;
        public CapSensorCore2() 
        {
            logger = NLog.LogManager.GetCurrentClassLogger();

            //假指令
            COMMREQ_pushData = new COMMREQInServer() { Prefix = COMMREQ.ToPrefix("PushData") };
        }
        public void PushHz(byte systick, byte channel, byte serial, UInt16 hz) 
        {
            List<byte> buf = new List<byte>();
            buf.Add((byte)'F');
            buf.Add(systick);

            byte b = (byte)(channel << 4 | (0xF & serial));
            buf.Add(b);
            buf.AddRange(BitConverter.GetBytes(hz));

            AddTran(new COMMREQInServer_Transaction()
            {
                commReq = COMMREQ_pushData,
                response = buf.ToArray()
            });
        }
        public void PushIn(byte systick, UInt16 istatus, UInt16 ichanged) 
        {
            List<byte> buf = new List<byte>();
            buf.Add((byte)'I');
            buf.Add(systick);

            buf.Add(0x0);
            buf.AddRange(BitConverter.GetBytes(istatus));
            buf.AddRange(BitConverter.GetBytes(ichanged));

            AddTran(new COMMREQInServer_Transaction()
            {
                commReq = COMMREQ_pushData,
                response = buf.ToArray()
            });
        }
        protected override void ParsePackAfterCheckCRC8(byte[] pack)
        {
            byte B0 = pack[0];
            bool PT = Misc.MyBase.CHECKBIT(B0, 7);
            if (!PT)
            {
                //服务器不应该收到推送的数据
            }
            else
            {

                ParseFuncPack(pack);
            }
        }

        protected override byte[] GetSendPack(COMMREQInServer_Transaction tran)
        {
            //找出 COMMREQ
            var commReq = tran.commReq;
            List<byte> pack = new List<byte>();

            byte B0 = packno;
            //添加B0
            if (commReq == COMMREQ_pushData)//数据推送包
            {
                packno++;
                Misc.MyBase.CLEARBIT(ref B0, 7);
            }
            else
            {
                Misc.MyBase.SIGNBIT(ref B0, 7);
            }
            pack.Add(B0);

            //添加前序
            if (commReq != COMMREQ_pushData)//数据推送包没有前序
                pack.AddRange(commReq.Prefix);


            //添加数据
            if (tran.response != null)
                pack.AddRange(tran.response);


            //转为 7E格式 
            var buf = GetSendPack(pack);

            return buf.ToArray();
        }
    }
}
