﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FObjBase;
namespace FLY.Simulation.Flyad7.OBJProxy
{
    class PUSH_DATA:FObj
    {

        FLYAD7 Data;
        UInt16 istatus;
        
        public PUSH_DATA(int objsys_idx, FLYAD7 data):base(objsys_idx)
        {
            ID = FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.ID;
            Data = data;

            Data.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(Data_PropertyChanged);

            Data.mPosGrid.PushEvent += new FLYAD7.PosGrid.PushEventHandler(mPosGrid_PushEvent);

            Data.TimeGridEvent += new FlyADBase.TimeGridEventHandler(Data_TimeGridEvent);

            Data.AdPushEvent += Data_AdPushEvent;
            Data.Pos1PushEvent += Data_Pos1PushEvent;
            Data.Pos2PushEvent += Data_Pos2PushEvent;
        }



        void Data_TimeGridEvent(object sender, FlyADBase.TimeGridEventArgs e)
        {
            CurrObjSys.PushObjInfoEx(
                this,
                FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_TIMEGRID,
                new FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushTGrid_2()
                {
                    data = e.Data,
                    systick = Data.GetSysTick(e.Time),
                }.ToBytes());
        }


        void mPosGrid_PushEvent(bool isMini, Misc.DIRECTION dir, int grid_start, int[] data)
        {
            FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushGrid_2 p = new FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushGrid_2();
            p.grid_start = grid_start;
            p.direction = dir;
            p.data = data;
            p.systick = Data.GetSysTick(Data.Now);
            p.marker = Data.Marker;
            if (isMini)
                CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_MINIGRID,
                        p.ToBytes());
            else
                CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_GRID,
                        p.ToBytes());
        }

 
        void Data_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == nameof(Data.IStatus)) 
            {
                UInt16 inchange = (UInt16)(istatus ^ Data.IStatus);
                istatus = Data.IStatus;

                CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_IO,
                    new FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushIO_2()
                    {
                        inChange = inchange,
                        istatus = Data.IStatus,
                        ostatus = Data.OStatus,
                        systick = Data.GetSysTick(),
                        pos1 = Data.Position,
                        pos2 = Data.Position2
                    }.ToBytes());
            }
            else if ((e.PropertyName == nameof(Data.DriveStatus))||(e.PropertyName == nameof(Data.Marker)))
            {
                CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_STATUS,
                    new FLYAD7_OBJ_INTERFACE.DRIVE_MAN_INTERFACE.Pack_DriveState_2
                    {
                        order = Data.DriveOrder,
                        status = Data.DriveStatus,
                        marker = Data.Marker,
                        systick = Data.GetSysTick(),
                        mode = 1
                    }.ToBytes());
            }
        }


        private void Data_Pos2PushEvent(object sender, PosPushEventArgs e)
        {
            CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_POS2,
                new FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushPos2_2()
                {
                    pos2 = e.Position,
                    speed2 = e.Speed,
                    systick = Data.GetSysTick()
                }.ToBytes());
        }

        private void Data_Pos1PushEvent(object sender, PosPushEventArgs e)
        {
            CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_POS1,
                new FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushPos1_2()
                {
                    pos1 = e.Position,
                    speed1 = e.Speed,
                    systick = Data.GetSysTick()
                }.ToBytes());
        }

        private void Data_AdPushEvent(object sender, AdPushEventArgs e)
        {
            CurrObjSys.PushObjInfoEx(this, FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.PUSH_AD1,
                new FLYAD7_OBJ_INTERFACE.PUSH_DATA_INTERFACE.Pack_PushAD1()
                {
                    AD = e.Ad,
                }.ToBytes());
        }
    }
}
