﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.Simulation
{
    public interface ISimulationGageAD
    {

        /// <summary>
        /// 获取AD值
        /// </summary>
        /// <returns></returns>
        int GetAD();

        /// <summary>
        /// 电容传感器 获取 AD值
        /// </summary>
        /// <returns></returns>
        int GetHz();

        /// <summary>
        /// 
        /// </summary>
        /// <param name="now"></param>
        void OnPoll(DateTime now);


        /// <summary>
        /// 给 AD盒 输入口状态
        /// </summary>
        /// <returns></returns>
        UInt16 GetInput();

        /// <summary>
        /// 获取编码器2
        /// </summary>
        /// <returns></returns>
        int GetPosition2();

        /// <summary>
        /// 获取速度2
        /// </summary>
        /// <returns></returns>
        int GetSpeed2();

        /// <summary>
        /// AD盒 接受到指令，设置输出口状态
        /// </summary>
        /// <param name="output"></param>
        void SetOutput(UInt16 output);

        /// <summary>
        /// AD盒 移动了，设置编码器1位置
        /// </summary>
        /// <param name="position"></param>
        void SetPosition(int position);

        /// <summary>
        /// 电容传感器获取同步信号
        /// </summary>
        /// <returns></returns>
        bool GetSyncIn();

        #region 参数
        /// <summary>
        /// 编码器1比例
        /// </summary>
        double Mmpp { get; set; }

        /// <summary>
        /// 机架长度 mm
        /// </summary>
        int TotalLengthMm { get; }

        /// <summary>
        /// 原点信号位置
        /// </summary>
        int OrgSignMm { get; set; }

        /// <summary>
        /// 膜宽,mm
        /// </summary>
        int FilmWidth { get; set; }

        /// <summary>
        /// 膜开始位置, mm
        /// </summary>
        int FilmBegin { get; set; }

        /// <summary>
        /// 传感器直径，单位mm
        /// </summary>
        int SenserWidth { get; set; }

        #endregion


        #region 探头气动装置
        /// <summary>
        /// 下压按钮被触发， 电箱的按钮<para/>
        /// 接X4, 没触发时X4=1, 触发时X4=0
        /// </summary>
        bool IsPushDownButtonTriggered { get; set; }

        /// <summary>
        /// 安装在探头前方的保护装置被触发 <para/>
        /// 接X5, 正常时X5=1, 当膜非常后，使保护装置抬起， X5=0
        /// </summary>
        bool IsSensorProtectionTrggered { get; set; }
        #endregion
    }
}
